<template>
  <div class="flex app-contair">
    <div class="app-breadcrumb">
      <!-- <el-breadcrumb class="app-breadcrumb" separator="/">
        <transition-group name="breadcrumb">
          <el-breadcrumb-item v-for="(item,index) in levelList" :key="item.path">
            <span v-if="item.redirect==='noRedirect'||index==levelList.length-1" class="no-redirect">{{ item.meta.title }}</span>
            <a v-else @click.prevent="handleLink(item)">{{ item.meta.title }}</a>
          </el-breadcrumb-item>
        </transition-group>
      </el-breadcrumb> -->
    </div>
    <div class="app-time">{{ time }}</div>
  </div>
</template>

<script>
import pathToRegexp from 'path-to-regexp'
import { parseTime } from '@/utils/index'
export default {
  data () {
    return {
      levelList: null,
      time: ''
    }
  },
  watch: {
    $route () {
      this.getBreadcrumb()
    }
  },
  created () {
    this.getBreadcrumb()
  },
  mounted () {
    setInterval(() => {
      this.time = parseTime(new Date())
    })
  },
  methods: {
    getBreadcrumb () {
      // only show routes with meta.title
      let matched = this.$route.matched.filter(item => item.meta && item.meta.title)
      const first = matched[0]

      if (!this.isDashboard(first)) {
        matched = [{ path: '/dashboard', meta: { title: '首页' } }].concat(matched)
      }

      this.levelList = matched.filter(item => item.meta && item.meta.title && item.meta.breadcrumb !== false)
    },
    isDashboard (route) {
      const name = route && route.name
      if (!name) {
        return false
      }
      return name.trim().toLocaleLowerCase() === 'Dashboard'.toLocaleLowerCase()
    },
    pathCompile (path) {
      // To solve this problem https://github.com/PanJiaChen/vue-element-admin/issues/561
      const { params } = this.$route
      var toPath = pathToRegexp.compile(path)
      return toPath(params)
    },
    handleLink (item) {
      const { redirect, path } = item
      if (redirect) {
        this.$router.push(redirect)
        return
      }
      this.$router.push(this.pathCompile(path))
    },
    historyRoute (i) {
      const path = this.levelList[i - 1].path
      this.levelList.splice(i, 1)
      this.$router.push(path)
    }
  }
}
</script>

<style lang="scss" scoped>
.app-contair {
  position: absolute;
  right: 57px;
  top: 65px;
  line-height: 48px;
  .app-time {
    font-size: 18px;
    font-family: DIN;
    font-weight: bold;
    color: #303133;
  }
  .route-breadcrumb {
    height: 32px;
    background: #f0f2fe;
    border: 1px solid #767eba;
    border-radius: 4px;
    display: inline-block;
    line-height: 32px;
    margin-right: 16px;
    padding: 0 13px;
    font-size: 16px;
    font-family: Microsoft YaHei;
    font-weight: 400;
    color: #767eba;
    cursor: pointer;
    transition: all 0.3s;
    i {
      color: #303133;
      margin-left: 5px;
    }
    &:last-child {
      margin-right: 0;
    }
  }
}
</style>
